#IMPORTS
import es
import cmdlib
import popuplib
import psyco
psyco.full()

#INFO
info = es.AddonInfo()
info.name        = "Server Modes"
info.version     = "1.0"
info.author      = "Tyjuji"
info.url         = "http://addons.eventscripts.com/addons/view/servermodes"
info.basename    = "servermodes"
info.description = "Switch between ffa,jail and cw"
 
### DONT EDIT ABOVE!!! ###
#### DONT EDIT BELOW!!! #### :P
spopup = None
def MenuSelect(userid, choice, popupname):
    if choice == 'ffa':
        es.doblock("servermodes/servermodes_ffa")
    elif choice == 'cw':
        es.doblock("servermodes/servermodes_cw")
    elif choice == 'jail':
        es.doblock("servermodes/servermodes_jail")

def load(): #load function
    global spopup
    spopup = popuplib.easymenu('Smodes popup','choice', MenuSelect)
    spopup.settitle("Select Server Mode")
    spopup.addoption('ffa', "Change to FFA mode")
    spopup.addoption('cw', "Change to CW mode")
    spopup.addoption('jail', "Change to JAIL mode")
    if not es.exists('variable', 'servermodes_ver'):
        es.regcmd('servermodes_ver', 'none', 'version cvar')
        es.set("servermodes_ver", info.version)
    if not es.exists('saycommand', '!ffa'):
        cmdlib.registerSayCommand('!ffa', saycmdffa, 'The say ffa command', 'use_smodesffa', 'ADMIN', saycmd_noauth)
    if not es.exists('saycommand', '!cw'):
        cmdlib.registerSayCommand('!cw', saycmdcw, 'The say cw command', 'use_smodescw', 'ADMIN', saycmd_noauth)
    if not es.exists('saycommand', '!jail'):
        cmdlib.registerSayCommand('!jail', saycmdjail, 'The say jail command', 'use_smodesjail', 'ADMIN', saycmd_noauth)
    if not es.exists('saycommand', '!smodes'):
        cmdlib.registerSayCommand('!smodes', popupsender, 'The popup sender', 'use_smodespopup', 'ADMIN', saycmd_noauth)
    if not es.exists('command', 'servermodes_mode'):
        es.regcmd('servermodes_mode', 'none', 'The NONE')

userid = es.getcmduserid()

def popupsender(userid, args):
    spopup.send(userid)

def saycmdjail(userid, args):
    es.doblock("servermodes/servermodes_jail")

def saycmdffa(userid, args):
    es.doblock("servermodes/servermodes_ffa")

def saycmdcw(userid, args):
    es.doblock("servermodes/servermodes_cw")

def none():
    es.ServerCommand('echo The Cookie Is A Lie? O.o')

def servermodes_ffa(): #the ffa function
    es.ServerCommand('exec server.cfg')
    es.msg('#multi #lightgreen [Server Modes]#default Changing to FFA Config')
    es.ServerCommand('exec servermodesffa.cfg')
    es.unload('hosties')
    es.set('servermodes_mode', ffa)

def servermodes_cw(): #the cw function
    es.ServerCommand('exec server.cfg')
    es.msg('#multi #lightgreen [Server Modes]#default Changing to CW config')
    es.ServerCommand('exec servermodescw.cfg')
    es.unload('hosties')
    es.set('servermodes_mode', cw)
    
def servermodes_jail(): #and the jail function
    es.ServerCommand('exec server.cfg')
    es.msg('#multi #lightgreen [Server Modes]#default Changing to Jail config')
    es.ServerCommand('exec servermodesjail.cfg')
    es.load('hosties')
    es.set('servermodes_mode', jail)

def es_map_start(ev):
    if servermodes_mode == ffa:
        es.doblock("servermodes/servermodes_ffa") #on map start it will change the settings to ffa mode
    elif servermodes_mode == cw:
        es.doblock("servermodes/servermodes_cw") #same as above just to cw settings
    elif servermodes_mode == jail:
        es.doblock("servermodes/servermodes_jail") #same as above just to jail settings

def saycmd_noauth(userid, args): #the noauth function
    es.tell(userid, '#multi #green [Server Modes]#lightgreen You are not Authorized!!!')

def unload(): #unload function OFC
    spopup.delete()
    cmdlib.unregisterSayCommand('!smodes')
    cmdlib.unregisterSayCommand('!ffa')
    cmdlib.unregisterSayCommand('!cw')
    cmdlib.unregisterSayCommand('!jail')